/*****************************************************************************
 * sc589_init_core0_Core0.h
 *****************************************************************************/

#ifndef __SC589_INIT_CORE0_CORE0_H__
#define __SC589_INIT_CORE0_CORE0_H__

#define MHZTOHZ       (1000000u)

#if defined(__ADSPSC589_FAMILY__)

/* the ARM core clock is generated from CGU0 */
#define CGU_DEV       (0)

/* default power settings */
#define DF_DEFAULT      (0x0u)
#if defined (__ADSPSC584__)
#define MSEL_DEFAULT    (0x10u)
#else
#define MSEL_DEFAULT    (0x12u)
#endif
#define SYSSEL_DEFAULT  (0x2u)
#define S0SEL_DEFAULT   (0x2u)
#define S1SEL_DEFAULT   (0x2u)
#define CSEL_DEFAULT    (0x1u)
#define DSEL_DEFAULT    (0x1u)

#define CLKIN         (25u  * MHZTOHZ)
#if defined(__ADSPSC584__)
#define CORE_MAX      (400u * MHZTOHZ)
#else
#define CORE_MAX      (450u * MHZTOHZ)
#endif
#define SYSCLK_MAX    (225u * MHZTOHZ)
#endif

/* dummy function - SoftConfig not available yet */
void ConfigSoftSwitches(void)
{
}

/*
** CGU initialization is activated by default
**
** To deactivate, comment out the __CONFIG_CGU__ #define below
*/
#define __CONFIG_CGU__

/*
** DMC memory initialization is activated by default for both DMC banks
**
** To deactivate one or both banks, comment out the appropriate __CONFIG_DMCx__ #define
** below
*/
#define __CONFIG_DMC0__
#if !defined(__ADSPSC584__) && !defined(__ADSPSC582__)
#define __CONFIG_DMC1__
#endif

#endif /* __SC589_INIT_CORE0_CORE0_H__ */
