/*
** InitCode_Core0.c
**
** Run initialization code to configure for ADSP-SC58x EZ-Board
**
** Copyright (c) 2011-2012 Analog Devices, Inc. All Rights Reserved.
**/



#include "InitCode_Core0.h"

DMC_PARAM DMC_Param_List;
void initcode(ADI_ROM_BOOT_CONFIG* pBootStruct)
{

#if defined(__CONFIG_CGU__)
/*
    uint32_t udUART_BIT_RATE = 0;
    uint32_t udUART_CTL = 0;

/ *****************************************************************************
   Mode 'Boot from UART host (slave mode)'
   Save current BIT RATE value and Force transfer stop before changing CGU
******************************************************************************** /

  if((*pREG_RCU0_STAT & BITM_RCU_STAT_BMODE) == (3 << BITP_RCU_STAT_BMODE))
  {
	  udUART_BIT_RATE = UartGetBitrate(0);
	  udUART_CTL = UartRxFifoClear(0, udUART_BIT_RATE);
  }
*/
	*pREG_PORTE_FER = 0;

	*pREG_PORTE_DIR_SET  = 0x00EE;

	int i,k=0;

	while(k<10)
		{

			*pREG_PORTE_DATA_TGL  = 0x0002;


			for(i=0; i<100000; i++);
			k++;
		}
	//init_cgu();
	Init_CGU();
	k=0;

	for(i=0; i<600000; i++);

/*
/ *****************************************************************************
      Mode 'Boot from UART host (slave mode)'
      Update UART Clock register according to new clock frequencies
      and restore UART Control Register
****************************************************************************** /

  if((*pREG_RCU0_STAT & BITM_RCU_STAT_BMODE) == (3 << BITP_RCU_STAT_BMODE))
   {
	  UartSetBitrate(0, udUART_BIT_RATE);
      *pREG_UART0_CTL = udUART_CTL;
   }
*/
#endif


#if defined(__CONFIG_MEMORY__)
	*pREG_PORTE_FER = 0;

	*pREG_PORTE_DIR_SET  = 0x00EE; //BITM_PORT_DIR_SET_PX0 | BITM_PORT_DIR_SET_PX1  ;		//	configure PA0 & PA1 as GP Output






	while(k<20)
		{

			*pREG_PORTE_DATA_TGL  = 0x0002; //BITM_PORT_DIR_SET_PX0 | BITM_PORT_DIR_SET_PX1;


			for(i=0; i<100000; i++);
			k++;
		}
	k=0;
	for(i=0; i<600000; i++);

#if defined(__ADSPSC584__)
		DMC_Init_Default(0, MEMTYPE_DDR2);
#elif defined(__ADSPSC589__)
		//Initialize the DMC parameters list
		DMC_Param_List.dmc_no=0;
		DMC_Param_List.ddr_mode=LPDDR_MODE;
		DMC_Param_List.phy_init_required=true;
		DMC_Param_List.cclk_dclk_ratio=2;
		DMC_Param_List.anomaly_20000037_applicable=true;
		DMC_Param_List.dmc_ctl_value=DMC_CTL_VALUE;
		DMC_Param_List.dmc_cfg_value=DMC_CFG_VALUE;
		DMC_Param_List.dmc_tr0_value=DMC_TR0_VALUE;
		DMC_Param_List.dmc_tr1_value=DMC_TR1_VALUE;
		DMC_Param_List.dmc_tr2_value=DMC_TR2_VALUE;
		DMC_Param_List.dmc_mr0_value=DMC_MR0_VALUE;
		DMC_Param_List.dmc_mr1_value=DMC_MR1_VALUE;
		DMC_Param_List.dmc_mr2_value=DMC_MR2_VALUE;
		DMC_Param_List.padctl2_value=DMC_PADCTL2_VALUE;
		DMC_Param_List.dmc_cphyctl_value=DMC_CPHYCTL_VALUE;
		DMC_Param_List.dmc_data_calib_add_value=DMC0_DATA_CALIB_ADD;

		//Initialize DMC0 now
		DMCInit(DMC_Param_List);

#endif
  	*pREG_PORTE_FER = 0;

  	*pREG_PORTE_DIR_SET  = 0x00EE;






  	while(k<20)
  		{

  			*pREG_PORTE_DATA_TGL  = 0x0040;


  			for(i=0; i<100000; i++);
  			k++;
  		}
  	k=0;

#if defined(__ADSPSC589__)
	//Initialize the DMC parameters list
	DMC_Param_List.dmc_no=1;
	DMC_Param_List.ddr_mode=LPDDR_MODE;
	DMC_Param_List.phy_init_required=true;
	DMC_Param_List.cclk_dclk_ratio=2;
	DMC_Param_List.anomaly_20000037_applicable=true;
	DMC_Param_List.dmc_ctl_value=DMC_CTL_VALUE;
	DMC_Param_List.dmc_cfg_value=DMC_CFG_VALUE;
	DMC_Param_List.dmc_tr0_value=DMC_TR0_VALUE;
	DMC_Param_List.dmc_tr1_value=DMC_TR1_VALUE;
	DMC_Param_List.dmc_tr2_value=DMC_TR2_VALUE;
	DMC_Param_List.dmc_mr0_value=DMC_MR0_VALUE;
	DMC_Param_List.dmc_mr1_value=DMC_MR1_VALUE;
	DMC_Param_List.dmc_mr2_value=DMC_MR2_VALUE;
	DMC_Param_List.padctl2_value=DMC_PADCTL2_VALUE;
	DMC_Param_List.dmc_cphyctl_value=DMC_CPHYCTL_VALUE;
	DMC_Param_List.dmc_data_calib_add_value=DMC1_DATA_CALIB_ADD;

	//Initialize DMC1 now
	DMCInit(DMC_Param_List);

#endif

  	while(k<20)
  		{

  			*pREG_PORTE_DATA_TGL  = 0x0040;


  			for(i=0; i<100000; i++);
  			k++;
  		}
  	k=0;
#endif



/*****************************************************************************
    BMODE 1: 'Boot from SPI memory (Master mode)'
    modify SPIx_BAUD register to speed up booting from SPI memory
******************************************************************************/
#if defined(__CHANGE_SPI_BAUD__)
   if ( (*pREG_RCU0_STAT & BITM_RCU_STAT_BMODE) == (1 << BITP_RCU_STAT_BMODE)  )
   {
       *pREG_SPI2_CLK = SPI_BAUD_VAL;
   }
#endif


}


void Init_CGU()
{
	//Default CGU Initialization - PLLCLK = 450 MHz, CCLK = 450 MHz, SYCLK = 225 MHz, DCLK = 450 MHz, SCLK0 = SCLK1 = 225 MHz
	_CGU_CLOCKDIVIDERS CGU0_PARAM_LIST_DEFAULT;
#if defined(__ADSPSC584__)
			CGU0_PARAM_LIST_DEFAULT.ctl_MSEL=16;
#elif defined(__ADSPSC589__)
			CGU0_PARAM_LIST_DEFAULT.ctl_MSEL=16;
#else
#error Please configure the clock speed for your board
#endif
			CGU0_PARAM_LIST_DEFAULT.ctl_DF=0;
			CGU0_PARAM_LIST_DEFAULT.div_CSEL=1;
			CGU0_PARAM_LIST_DEFAULT.div_SYSSEL=2;
			CGU0_PARAM_LIST_DEFAULT.div_S0SEL=2;
			CGU0_PARAM_LIST_DEFAULT.div_S1SEL=2;
			CGU0_PARAM_LIST_DEFAULT.div_DSEL=2;

			//Set the DLLRST bit (bit 11 of the DMC_PHY_CTL0 register) before CGU Initialization. More details at http://www.spd.analog.com/issues/dsp_pte_dev/issuemgr.cgi?item=36-10-0001
			*pREG_DMC0_PHY_CTL0 |=0x800;
#if defined(__ADSPSC589__)
			*pREG_DMC1_PHY_CTL0 |=0x800;
#endif


			CGU_Init(0, 0, &CGU0_PARAM_LIST_DEFAULT,0);

			//delay(1000);
			//Clear the DLLRST bit (bit 11 of the DMC_PHY_CTL0 register) after CGU Initialization. More details at http://www.spd.analog.com/issues/dsp_pte_dev/issuemgr.cgi?item=36-10-0001
			*pREG_DMC0_PHY_CTL0 =0x000;
#if defined(__ADSPSC589__)
			*pREG_DMC1_PHY_CTL0=0x000;
#endif

			}



