/*
**  InitCode_Core0.h
**
**  Configures the SC58x initcode EXE via the presence or absence
**  of macro #defines in this header.
**
**  Copyright (c) 2011-2013 Analog Devices, Inc. All Rights Reserved.
**
******************************************************************
**/

#ifndef __INITCODE_CORE0_H__
#define __INITCODE_CORE0_H__


#if defined(__ADSPSC58x__)
#include "cdefSC589.h"
#include <cdefSC58x_rom_otpLayout.h>
#include <cdefSC58x_rom.h>
#include <defSC58x_rom_jumptable.h>
#include <defSC58x_rom.h>
#include "sysreg.h"
#include "math.h"
#include "stdint.h"
#include "stdio.h"
#include "stdlib.h"
#include "stdarg.h"
#include "string.h"
#include "builtins.h"
#include <sys/platform.h>
#include <sys/adi_core.h>
#include "CGUInit.h"
#include "DMCInit.h"



#else
#error "Expected target processor ADSP-BF707"
#endif



#define CLKIN_Hz              25000000  /* CLKIN [Hz]   */
#define CLKIN_ns (1000000000/CLKIN_Hz)  /* CLKIN [ns]   */


/*
** CGU initialization is activated by default
**
** To deactivate, comment out the __CONFIG_CGU__ #define below
*/
#define __CONFIG_CGU__

/*
** DDR2 memory initialization is activated by default
**
** To deactivate, comment out the __CONFIG_MEMORY__ #define below
*/
#define __CONFIG_MEMORY__

/*
* For Boot from SPI memory,this definition will modify the SPI_BAUD
* register value and can in/decrease boot speed
*
* Boot ROM default: 0x1F
*
*/

//#define __CHANGE_SPI_BAUD__

#ifdef __CHANGE_SPI_BAUD__
	#define SPI_BAUD_VAL      0x1  /* SPI Clock max is 50MHz. */
#endif


/* Add your custom header content here */

#endif /* __INITCODE_CORE0_H__ */
